/*
   +----------------------------------------------------------------------+
   | HipHop for PHP                                                       |
   +----------------------------------------------------------------------+
   | Copyright (c) 2010-2013 Facebook, Inc. (http://www.facebook.com)     |
   | Copyright (c) 1997-2010 The PHP Group                                |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
*/

#ifndef incl_HPHP_EXT_PREG_H_
#define incl_HPHP_EXT_PREG_H_

// >>>>>> Generated by idl.php. Do NOT modify. <<<<<<

#include "hphp/runtime/base/base-includes.h"

namespace HPHP {
///////////////////////////////////////////////////////////////////////////////
// pcre

Variant f_preg_grep(const String& pattern, CArrRef input, int flags = 0);

Variant f_preg_match(const String& pattern, const String& subject, VRefParam matches = uninit_null(),
                     int flags = 0, int offset = 0);

Variant f_preg_match_all(const String& pattern, const String& subject, VRefParam matches,
                         int flags = 0, int offset = 0);

Variant f_preg_replace(CVarRef pattern, CVarRef replacement, CVarRef subject,
                       int limit = -1, VRefParam count = uninit_null());

Variant f_preg_replace_callback(CVarRef pattern, CVarRef callback,
                                CVarRef subject, int limit = -1,
                                VRefParam count = uninit_null());

Variant f_preg_split(CVarRef pattern, CVarRef subject, int limit = -1,
                     int flags = 0);

String f_preg_quote(const String& str, const String& delimiter = null_string);

int64_t f_preg_last_error();

///////////////////////////////////////////////////////////////////////////////
// deprecating these

String f_ereg_replace(const String& pattern, const String& replacement, const String& str);
String f_eregi_replace(const String& pattern, const String& replacement, const String& str);
Variant f_ereg(const String& pattern, const String& str, VRefParam regs = uninit_null());
Variant f_eregi(const String& pattern, const String& str, VRefParam regs = uninit_null());
Variant f_split(const String& pattern, const String& str, int limit = -1);
Variant f_spliti(const String& pattern, const String& str, int limit = -1);
String f_sql_regcase(const String& str);

///////////////////////////////////////////////////////////////////////////////
}

#endif // incl_HPHP_EXT_PREG_H_
